SystemOrganization addCategory: #PDS!

Object subclass: #Component
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS'!

!Component commentStamp: 'MatteoST 12/8/2014 18:20' prior: 0!
A Component is the top class of the "Composite pattern".
!

!Component methodsFor: 'accessing' stamp: 'MatteoST 12/13/2014 21:48'!
duration
	"comment stating purpose of message"

	^self shouldBeImplemented.! !

!Component methodsFor: 'accessing' stamp: 'MatteoST 12/24/2014 15:53'!
exist: aComponent
	"Checks if a equal Component already exists in the structure"

	^self shouldBeImplemented.! !

Component subclass: #Composite
	instanceVariableNames: 'compo_A compo_B'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS'!

!Composite commentStamp: 'sonmi 12/12/2014 17:56' prior: 0!
A Composite is a Component.
!

!Composite class methodsFor: 'initialize-release' stamp: 'MatteoST 12/20/2014 23:13'!
left: aComponent_A right:aComponent_B
	"Composite instance creation"

	| oggetto |
	oggetto := self new.
	oggetto compo_A: aComponent_A.
	oggetto compo_B:  aComponent_B.
	^oggetto.! !

!Composite methodsFor: 'accessing' stamp: 'MatteoST 12/20/2014 23:04'!
compo_A
	^ compo_A! !

!Composite methodsFor: 'accessing' stamp: 'MatteoST 12/20/2014 23:04'!
compo_A: aComponent
	compo_A := aComponent! !

!Composite methodsFor: 'accessing' stamp: 'MatteoST 12/20/2014 23:05'!
compo_B
	^ compo_B! !

!Composite methodsFor: 'accessing' stamp: 'MatteoST 12/20/2014 23:05'!
compo_B: aComponent
	compo_B := aComponent! !

!Composite methodsFor: 'accessing' stamp: 'MatteoST 12/16/2014 23:12'!
duration
	"calculates duration inside its heirachy"
	
	^(compo_A duration + compo_B duration).! !

!Composite methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/24/2014 16:12'!
exist: aComponent
	"Check componet equality"
	
	|controllo|
	"^((compo_A exist: aComponent) ifFalse: [^compo_B exist: aComponent])."
	controllo :=((compo_A exist: aComponent) or: (compo_B exist: aComponent)) or: (self==aComponent).	
	
	^controllo.! !

Component subclass: #Terminal
	instanceVariableNames: 'duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS'!

!Terminal commentStamp: 'sonmi 12/12/2014 17:57' prior: 0!
A Terminal is a component leaf.
!

!Terminal class methodsFor: 'initialize' stamp: 'MatteoST 12/20/2014 23:17'!
setDuration: anInteger
	"Create a leaf object with an initial duration"

	| oggetto |
	oggetto := Terminal new.
	oggetto duration: anInteger.
	^oggetto.! !

!Terminal methodsFor: 'accessing' stamp: 'MatteoST 12/13/2014 21:45'!
duration
	^ duration! !

!Terminal methodsFor: 'accessing' stamp: 'MatteoST 12/13/2014 21:45'!
duration: anInteger
	duration := anInteger.
	^self.! !

!Terminal methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/24/2014 16:12'!
exist: aComponent
	"Check componet equality"

	|controllo|
	controllo:=self==aComponent.
	"Transcript show: 'Term: '; show: controllo;cr."
	^controllo.! !

Object subclass: #Policy
	instanceVariableNames: 'policyNumber coverageStartDate lengthOfCoverage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS'!

!Policy commentStamp: 'MatteoST 11/29/2014 15:37' prior: 0!
A Policy is anObject.

Instance Variables
	coverageStartDate:		<Object>
	lengthOfCoverage:		<Object>
	policyNumber:		<Object>

coverageStartDate
	- xxxxx

lengthOfCoverage
	- xxxxx

policyNumber
	- xxxxx
!

!Policy class methodsFor: 'as yet unclassified' stamp: 'MatteoST 11/29/2014 18:11'!
policyNumber: anInteger 
	|aPolicy|
	aPolicy := self new.
	aPolicy policyNumber: anInteger.
	^aPolicy.! !

!Policy methodsFor: 'as yet unclassified' stamp: 'MatteoST 11/29/2014 15:38'!
derivedPolicy
	"create a copy of the policy"

	^self copy! !

!Policy methodsFor: 'accessing' stamp: 'MatteoST 11/29/2014 18:10'!
policyNumber
	"Returns the policy number"

	^policyNumber! !

!Policy methodsFor: 'accessing' stamp: 'MatteoST 11/29/2014 18:10'!
policyNumber: anInteger 
	policyNumber := anInteger.
	^self.! !

Object subclass: #SingletonHierachy
	instanceVariableNames: 'data'
	classVariableNames: 'uniqueInstance'
	poolDictionaries: ''
	category: 'PDS'!

!SingletonHierachy commentStamp: 'MatteoST 12/3/2014 21:49' prior: 0!
A SingletonHierachy is a class that develop the Singleton pattern over a hierachy.

Instance Variables
	data:		<Object>

data
	- xxxxx
!

SingletonHierachy subclass: #SingleSon
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS'!

!SingleSon commentStamp: 'sonmi 12/3/2014 11:55' prior: 0!
A SingleSon is aSingleton.

Instance Variables
	value:		generic basic value to store

value
	- number or letter


Test code for this class: 

| single tangle iniziale|
iniziale := Singleton current.
single := SingleSon current.
single value:740.
tangle := Singleton current.
tangle == single.
"the two instances referes to the same object, even if the frst instantiastion is a Singleton, and not a SingleSon isntance"!

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/5/2014 08:18'!
valore
	^ valore! !

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/5/2014 08:18'!
valore: anObject
	valore := anObject! !

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/3/2014 11:50'!
value
	"Returns the value instance"

	^value.! !

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/3/2014 11:50'!
value:anInteger
	"Store an integer in the variable value"

	value := anInteger.
	^self.! !

SingleSon subclass: #SingleSonSon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS'!

!SingleSonSon commentStamp: 'MatteoST 12/3/2014 21:51' prior: 0!
A SingleSonSon is a deeper class of the SingletonHierachy.
!

!SingletonHierachy class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/8/2014 11:52'!
current
	"Return the unique instance of the singleton pattern"
	
	"The singleton instance is bound to the toplevel class: in this way there's no doubt which calss the singleton belongs. If 'self' is used then it is not possinle to control if the instance is referred to the topcass or one of its sons. So the client do not know if the son interface is available, so it is more secure to use only the top class interface, but at this point it's bettere to get explicit use of the top class in the instatiantion of the Singleton for an Hierachy"
	uniqueInstance isNil ifTrue: [ uniqueInstance := SingletonHierachy basicNew  ]. 
	^uniqueInstance.! !

!SingletonHierachy class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/3/2014 22:00'!
destroy
	"Destroys the singleton unique instances"

	uniqueInstance := nil.
	^self.! !

!SingletonHierachy class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/3/2014 22:01'!
new
	"Forbids the use un new message"

	self error: 'Please do not use the ''new'' message, this is a singleton'.! !

!SingletonHierachy methodsFor: 'accessing' stamp: 'MatteoST 12/3/2014 22:02'!
data
	^ data! !

!SingletonHierachy methodsFor: 'accessing' stamp: 'MatteoST 12/3/2014 22:02'!
data: anInteger
	data := anInteger! !
